<template>
    <table class="table table-striped table-dark table-hover">
                    <thead>
                        <tr style="text-align:center">
                            <th colspan="2">
                                <select v-model="sortParam" class="custom-select">
                                    <option value="author">Сортировка по автору</option>
                                    <option value="date">Сортировка по дате</option>
                                    <option value="title">Сортировка по названию</option>
                                </select>
                            </th>
                            <th colspan="2">
                                <form ref="form" method='post' action='/parser' v-if="!showAlert" >
                                    <input type="hidden" name="_token" :value="csrf" />
                                    <button type="submit" class="btn btn-outline-light" @click="showAlert = true; onSubmit()">Обновить данные по статьям</button>
                                </form>
                                 <div v-else class="alert alert-warning" role="alert" style="margin:0;">
                                    Обновление статей ... 
                                </div>   
                            </th>
                        </tr>
                    </thead>
                    <tbody>
                       <tr>
                            <th scope="col">Дата публикации</th>
                            <th scope="col">Название статьи</th>
                            <th scope="col">Автор</th>
                            <th scope="col">Теги</th>
                        </tr>
                        <tr v-for="article in sortedList" v-bind:key="article.id">
                            <th scope="col">{{article.date}}</th>
                            <th scope="col"><a :href="article.link">{{article.title}}</a></th>
                            <th scope="col">{{article.author}}</th>
                            <th scope="col">{{article.tags}}</th>
                        </tr>
                    </tbody>  
                </table> 
</template>

<script>
    export default {
        data: function() {
            return  {
                articles: [],
                sortParam: 'author',
                showAlert: false,
                csrf: document.querySelector('meta[name="csrf-token"]').getAttribute('content'),
            }
        },
        mounted() {
           this.getArticle();
        },
        methods: {
            getArticle: function(){
                axios.post('/articles').then((response)=>{
                    this.articles = response.data;
                });
            },
            onSubmit: function () {
                this.$refs.form.submit();
            }
        },
        computed: {
            sortedList () {
                switch(this.sortParam){
                    case 'title': return this.articles.sort(sortByTitle);
                    case 'author': return this.articles.sort(sortByAuthor);
                    case 'date': return this.articles.sort(sortByDate);
                    default: return this.articles;
                }
            }
        }
    }

    var sortByTitle = function (d1, d2) {return (d1.title.toLowerCase() > d2.title.toLowerCase()) ? 1 : -1;};
    var sortByAuthor = function (d1, d2) { return (d1.author.toLowerCase() > d2.author.toLowerCase()) ? 1 : -1; };
    var sortByDate = function (d1, d2) { return (d1.date > d2.date) ? 1 : -1; };
</script>
